/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SourceEngineDTO type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SourceEngineDTO{}

// SourceEngineDTO struct for SourceEngineDTO
type SourceEngineDTO struct {
	Name          *string `json:"name,omitempty"`
	Region        *string `json:"region,omitempty"`
	EncryptionKey *string `json:"encryptionKey,omitempty"`
}

// NewSourceEngineDTO instantiates a new SourceEngineDTO object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSourceEngineDTO() *SourceEngineDTO {
	this := SourceEngineDTO{}
	return &this
}

// NewSourceEngineDTOWithDefaults instantiates a new SourceEngineDTO object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSourceEngineDTOWithDefaults() *SourceEngineDTO {
	this := SourceEngineDTO{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *SourceEngineDTO) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SourceEngineDTO) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *SourceEngineDTO) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *SourceEngineDTO) SetName(v string) {
	o.Name = &v
}

// GetRegion returns the Region field value if set, zero value otherwise.
func (o *SourceEngineDTO) GetRegion() string {
	if o == nil || IsNil(o.Region) {
		var ret string
		return ret
	}
	return *o.Region
}

// GetRegionOk returns a tuple with the Region field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SourceEngineDTO) GetRegionOk() (*string, bool) {
	if o == nil || IsNil(o.Region) {
		return nil, false
	}
	return o.Region, true
}

// HasRegion returns a boolean if a field has been set.
func (o *SourceEngineDTO) HasRegion() bool {
	if o != nil && !IsNil(o.Region) {
		return true
	}

	return false
}

// SetRegion gets a reference to the given string and assigns it to the Region field.
func (o *SourceEngineDTO) SetRegion(v string) {
	o.Region = &v
}

// GetEncryptionKey returns the EncryptionKey field value if set, zero value otherwise.
func (o *SourceEngineDTO) GetEncryptionKey() string {
	if o == nil || IsNil(o.EncryptionKey) {
		var ret string
		return ret
	}
	return *o.EncryptionKey
}

// GetEncryptionKeyOk returns a tuple with the EncryptionKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SourceEngineDTO) GetEncryptionKeyOk() (*string, bool) {
	if o == nil || IsNil(o.EncryptionKey) {
		return nil, false
	}
	return o.EncryptionKey, true
}

// HasEncryptionKey returns a boolean if a field has been set.
func (o *SourceEngineDTO) HasEncryptionKey() bool {
	if o != nil && !IsNil(o.EncryptionKey) {
		return true
	}

	return false
}

// SetEncryptionKey gets a reference to the given string and assigns it to the EncryptionKey field.
func (o *SourceEngineDTO) SetEncryptionKey(v string) {
	o.EncryptionKey = &v
}

func (o SourceEngineDTO) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SourceEngineDTO) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Region) {
		toSerialize["region"] = o.Region
	}
	if !IsNil(o.EncryptionKey) {
		toSerialize["encryptionKey"] = o.EncryptionKey
	}
	return toSerialize, nil
}

type NullableSourceEngineDTO struct {
	value *SourceEngineDTO
	isSet bool
}

func (v NullableSourceEngineDTO) Get() *SourceEngineDTO {
	return v.value
}

func (v *NullableSourceEngineDTO) Set(val *SourceEngineDTO) {
	v.value = val
	v.isSet = true
}

func (v NullableSourceEngineDTO) IsSet() bool {
	return v.isSet
}

func (v *NullableSourceEngineDTO) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSourceEngineDTO(val *SourceEngineDTO) *NullableSourceEngineDTO {
	return &NullableSourceEngineDTO{value: val, isSet: true}
}

func (v NullableSourceEngineDTO) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSourceEngineDTO) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
